// required for old g++ to compile PRId64 macros, see
// https://github.com/pytorch/pytorch/issues/3571
// for context
#define __STDC_FORMAT_MACROS

#include <ATen/SparseCPUType.h>

// @generated by aten/src/ATen/gen.py from SparseTypeDerived.cpp

#include <ATen/CPUGeneratorImpl.h>
#include <c10/core/Allocator.h>
#include <ATen/DeviceGuard.h>
#include <ATen/NativeFunctions.h>
#include <ATen/Utils.h>
#include <ATen/WrapDimUtils.h>
#include <ATen/Dispatch.h>
#include <c10/util/Half.h>
#include <c10/core/UndefinedTensorImpl.h>
#include <c10/util/Optional.h>
#include <torch/library.h>

#include <cstddef>
#include <functional>
#include <memory>
#include <utility>

#include <ATen/Config.h>


namespace {
static const char* named_tensors_unsupported_error =
  " is not yet supported with named tensors. Please drop names via "
  "`tensor = tensor.rename(None)`, call the op with an unnamed tensor, "
  "and set names on the result of the operation.";
}

namespace at {

namespace SparseCPUType {

Tensor add_Tensor(const Tensor & self, const Tensor & other, Scalar alpha) {
    return at::native::add_sparse(self, other, alpha);
}
Tensor & add__Tensor(Tensor & self, const Tensor & other, Scalar alpha) {
    return at::native::add_sparse_(self, other, alpha);
}
Tensor & add_out_out(Tensor & out, const Tensor & self, const Tensor & other, Scalar alpha) {
    return at::native::add_out_sparse_cpu(out, self, other, alpha);
}
Tensor bmm(const Tensor & self, const Tensor & mat2) {
    return at::native::bmm_sparse_cpu(self, mat2);
}
Tensor & bmm_out_out(Tensor & out, const Tensor & self, const Tensor & mat2) {
    return at::native::bmm_out_sparse_cpu(out, self, mat2);
}
Tensor div_Tensor(const Tensor & self, const Tensor & other) {
    return at::native::div_sparse(self, other);
}
Tensor & div__Tensor(Tensor & self, const Tensor & other) {
    return at::native::div_sparse_(self, other);
}
Tensor & div_out_out(Tensor & out, const Tensor & self, const Tensor & other) {
    return at::native::div_out_sparse_zerodim(out, self, other);
}
Tensor empty_memory_format(IntArrayRef size, const TensorOptions & options, c10::optional<MemoryFormat> memory_format) {
    return at::native::empty_sparse(size, options, memory_format);
}
Tensor floor_divide(const Tensor & self, const Tensor & other) {
    return at::native::floor_divide_sparse(self, other);
}
Tensor & floor_divide__Tensor(Tensor & self, const Tensor & other) {
    return at::native::floor_divide_sparse_(self, other);
}
Tensor & floor_divide_out_out(Tensor & out, const Tensor & self, const Tensor & other) {
    return at::native::floor_divide_out_sparse_zerodim(out, self, other);
}
Tensor isnan(const Tensor & self) {
    return at::native::isnan_sparse(self);
}
Tensor & log1p_(Tensor & self) {
    return at::native::log1p_sparse_(self);
}
Tensor & log1p_out_out(Tensor & out, const Tensor & self) {
    return at::native::log1p_out_sparse(out, self);
}
Tensor mm(const Tensor & self, const Tensor & mat2) {
    return at::native::_sparse_mm(self, mat2);
}
Tensor & mm_out_out(Tensor & out, const Tensor & self, const Tensor & mat2) {
    return at::native::_sparse_mm_out(out, self, mat2);
}
Tensor mul_Tensor(const Tensor & self, const Tensor & other) {
    return at::native::mul_sparse(self, other);
}
Tensor & mul__Tensor(Tensor & self, const Tensor & other) {
    return at::native::mul_sparse_(self, other);
}
Tensor & mul_out_out(Tensor & out, const Tensor & self, const Tensor & other) {
    return at::native::mul_out_sparse_cpu(out, self, other);
}
Tensor mv(const Tensor & self, const Tensor & vec) {
    return at::native::mv_sparse(self, vec);
}
Tensor narrow_copy(const Tensor & self, int64_t dim, int64_t start, int64_t length) {
    return at::native::narrow_copy_sparse(self, dim, start, length);
}
Tensor & sspaddmm_out_out(Tensor & out, const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) {
    return at::native::_sspaddmm_out_cpu(out, self, mat1, mat2, beta, alpha);
}
Tensor true_divide_Tensor(const Tensor & self, const Tensor & other) {
    return at::native::true_divide_sparse(self, other);
}
Tensor & true_divide__Tensor(Tensor & self, const Tensor & other) {
    return at::native::true_divide_sparse_(self, other);
}
Tensor & true_divide_out_out(Tensor & out, const Tensor & self, const Tensor & other) {
    return at::native::true_divide_out_sparse_zerodim(out, self, other);
}
Tensor native_norm(const Tensor & self, Scalar p) {
    return at::native::norm_sparse(self, p);
}
Tensor _sparse_sum_backward(const Tensor & grad, const Tensor & self, IntArrayRef dim) {
    return at::native::_sparse_sum_backward_cpu(grad, self, dim);
}
Tensor _sparse_softmax(const Tensor & self, int64_t dim, bool half_to_float) {
    return at::native::softmax_sparse_cpu(self, dim, half_to_float);
}
Tensor _sparse_softmax_backward_data(const Tensor & grad_output, const Tensor & output, int64_t dim, const Tensor & self) {
    return at::native::softmax_backward_sparse_cpu(grad_output, output, dim, self);
}
Tensor _sparse_log_softmax(const Tensor & self, int64_t dim, bool half_to_float) {
    return at::native::log_softmax_sparse_cpu(self, dim, half_to_float);
}
Tensor _sparse_log_softmax_backward_data(const Tensor & grad_output, const Tensor & output, int64_t dim, const Tensor & self) {
    return at::native::log_softmax_backward_sparse_cpu(grad_output, output, dim, self);
}
Tensor clone(const Tensor & self, c10::optional<MemoryFormat> memory_format) {
    return at::native::clone_sparse(self, memory_format);
}
Tensor & pow_out_Tensor_Scalar_out(Tensor & out, const Tensor & self, Scalar exponent) {
    return at::native::pow_out_sparse_scalar(out, self, exponent);
}
Tensor pow_Tensor_Scalar(const Tensor & self, Scalar exponent) {
    return at::native::pow_sparse_scalar(self, exponent);
}
Tensor & zero_(Tensor & self) {
    return at::native::zero_sparse_(self);
}
Tensor & sub_out_out(Tensor & out, const Tensor & self, const Tensor & other, Scalar alpha) {
    return at::native::sub_out_sparse(out, self, other, alpha);
}
Tensor sub_Tensor(const Tensor & self, const Tensor & other, Scalar alpha) {
    return at::native::sub_sparse(self, other, alpha);
}
Tensor & sub__Tensor(Tensor & self, const Tensor & other, Scalar alpha) {
    return at::native::sub_sparse_(self, other, alpha);
}
Tensor & addmm_out_out(Tensor & out, const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) {
    return at::native::addmm_out_sparse_dense_cpu(out, self, mat1, mat2, beta, alpha);
}
Tensor addmm(const Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) {
    return at::native::addmm_sparse_dense_cpu(self, mat1, mat2, beta, alpha);
}
Tensor & addmm_(Tensor & self, const Tensor & mat1, const Tensor & mat2, Scalar beta, Scalar alpha) {
    return at::native::s_addmm_sparse_dense_cpu_(self, mat1, mat2, beta, alpha);
}
Tensor _sparse_coo_tensor_with_dims(int64_t sparse_dim, int64_t dense_dim, IntArrayRef size, const TensorOptions & options) {
    return at::native::new_with_dims_sparse(sparse_dim, dense_dim, size, options);
}
Tensor _sparse_coo_tensor_with_dims_and_tensors(int64_t sparse_dim, int64_t dense_dim, IntArrayRef size, const Tensor & indices, const Tensor & values, const TensorOptions & options) {
    return at::native::new_with_dims_and_tensor_sparse(sparse_dim, dense_dim, size, indices, values, options);
}
Tensor & sparse_resize_(Tensor & self, IntArrayRef size, int64_t sparse_dim, int64_t dense_dim) {
    return at::native::sparse_resize_(self, size, sparse_dim, dense_dim);
}
Tensor & sparse_resize_and_clear_(Tensor & self, IntArrayRef size, int64_t sparse_dim, int64_t dense_dim) {
    return at::native::sparse_resize_and_clear_(self, size, sparse_dim, dense_dim);
}
Tensor sparse_mask(const Tensor & self, const Tensor & mask) {
    return at::native::sparse_mask_cpu(self, mask);
}
Tensor to_dense(const Tensor & self) {
    return at::native::sparse_to_dense(self);
}
int64_t sparse_dim(const Tensor & self) {
    return at::native::sparse_dim_sparse(self);
}
int64_t _dimI(const Tensor & self) {
    return at::native::sparse_dim_sparse(self);
}
int64_t dense_dim(const Tensor & self) {
    return at::native::dense_dim_sparse(self);
}
int64_t _dimV(const Tensor & self) {
    return at::native::dense_dim_sparse(self);
}
int64_t _nnz(const Tensor & self) {
    return at::native::_nnz_sparse(self);
}
Tensor coalesce(const Tensor & self) {
    return at::native::coalesce_sparse_cpu(self);
}
bool is_coalesced(const Tensor & self) {
    return at::native::is_coalesced_sparse(self);
}
Tensor _indices(const Tensor & self) {
    return at::native::_indices_sparse(self);
}
Tensor _values(const Tensor & self) {
    return at::native::_values_sparse(self);
}
Tensor & _coalesced_(Tensor & self, bool coalesced) {
    return at::native::_coalesced_sparse_(self, coalesced);
}
Tensor indices(const Tensor & self) {
    return at::native::indices_sparse(self);
}
Tensor values(const Tensor & self) {
    return at::native::values_sparse(self);
}
Tensor & hspmm_out_out(Tensor & out, const Tensor & mat1, const Tensor & mat2) {
    return at::native::hspmm_out_sparse_cpu(out, mat1, mat2);
}
Tensor hspmm(const Tensor & mat1, const Tensor & mat2) {
    return at::native::hspmm_sparse_cpu(mat1, mat2);
}
Tensor & copy_sparse_to_sparse_(Tensor & self, const Tensor & src, bool non_blocking) {
    return at::native::copy_sparse_(self, src, non_blocking);
}
Tensor index_select(const Tensor & self, int64_t dim, const Tensor & index) {
    return at::native::index_select_sparse(self, dim, index);
}
Tensor any(const Tensor & self) {
    return at::native::any_sparse(self);
}

}  // namespace SparseCPUType

TORCH_LIBRARY_IMPL(aten, SparseCPU, m) {
  m.impl("add.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::add_Tensor))
  );
  m.impl("add_.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::add__Tensor))
  );
  m.impl("add.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::add_out_out))
  );
  m.impl("bmm",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::bmm))
  );
  m.impl("bmm.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::bmm_out_out))
  );
  m.impl("div.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::div_Tensor))
  );
  m.impl("div_.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::div__Tensor))
  );
  m.impl("div.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::div_out_out))
  );
  m.impl("empty.memory_format",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::empty_memory_format))
  );
  m.impl("floor_divide",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::floor_divide))
  );
  m.impl("floor_divide_.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::floor_divide__Tensor))
  );
  m.impl("floor_divide.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::floor_divide_out_out))
  );
  m.impl("isnan",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::isnan))
  );
  m.impl("log1p_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::log1p_))
  );
  m.impl("log1p.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::log1p_out_out))
  );
  m.impl("mm",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::mm))
  );
  m.impl("mm.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::mm_out_out))
  );
  m.impl("mul.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::mul_Tensor))
  );
  m.impl("mul_.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::mul__Tensor))
  );
  m.impl("mul.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::mul_out_out))
  );
  m.impl("mv",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::mv))
  );
  m.impl("narrow_copy",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::narrow_copy))
  );
  m.impl("sspaddmm.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::sspaddmm_out_out))
  );
  m.impl("true_divide.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::true_divide_Tensor))
  );
  m.impl("true_divide_.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::true_divide__Tensor))
  );
  m.impl("true_divide.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::true_divide_out_out))
  );
  m.impl("native_norm",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::native_norm))
  );
  m.impl("_sparse_sum_backward",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_sparse_sum_backward))
  );
  m.impl("_sparse_softmax",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_sparse_softmax))
  );
  m.impl("_sparse_softmax_backward_data",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::_sparse_softmax_backward_data))
  );
  m.impl("_sparse_log_softmax",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_sparse_log_softmax))
  );
  m.impl("_sparse_log_softmax_backward_data",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::_sparse_log_softmax_backward_data))
  );
  m.impl("clone",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::clone))
  );
  m.impl("pow.Tensor_Scalar_out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::pow_out_Tensor_Scalar_out))
  );
  m.impl("pow.Tensor_Scalar",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::pow_Tensor_Scalar))
  );
  m.impl("zero_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::zero_))
  );
  m.impl("sub.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::sub_out_out))
  );
  m.impl("sub.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::sub_Tensor))
  );
  m.impl("sub_.Tensor",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::sub__Tensor))
  );
  m.impl("addmm.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::addmm_out_out))
  );
  m.impl("addmm",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::addmm))
  );
  m.impl("addmm_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::addmm_))
  );
  m.impl("_sparse_coo_tensor_with_dims",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::_sparse_coo_tensor_with_dims))
  );
  m.impl("_sparse_coo_tensor_with_dims_and_tensors",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::_sparse_coo_tensor_with_dims_and_tensors))
  );
  m.impl("sparse_resize_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::sparse_resize_))
  );
  m.impl("sparse_resize_and_clear_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::sparse_resize_and_clear_))
  );
  m.impl("sparse_mask",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::sparse_mask))
  );
  m.impl("to_dense",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::to_dense))
  );
  m.impl("sparse_dim",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::sparse_dim))
  );
  m.impl("_dimI",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_dimI))
  );
  m.impl("dense_dim",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::dense_dim))
  );
  m.impl("_dimV",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_dimV))
  );
  m.impl("_nnz",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_nnz))
  );
  m.impl("coalesce",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::coalesce))
  );
  m.impl("is_coalesced",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::is_coalesced))
  );
  m.impl("_indices",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_indices))
  );
  m.impl("_values",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::_values))
  );
  m.impl("_coalesced_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::_coalesced_))
  );
  m.impl("indices",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::indices))
  );
  m.impl("values",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::values))
  );
  m.impl("hspmm.out",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::hspmm_out_out))
  );
  m.impl("hspmm",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::hspmm))
  );
  m.impl("copy_sparse_to_sparse_",
         torch::dispatch(DispatchKey::SparseCPU,
                         torch::CppFunction::makeUnboxedOnly(&SparseCPUType::copy_sparse_to_sparse_))
  );
  m.impl("index_select",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::index_select))
  );
  m.impl("any",
         torch::dispatch(DispatchKey::SparseCPU,
                         TORCH_FN(SparseCPUType::any))
  );;
}

} // namespace at
